#! /bin/sh
#
# /etc/init.d/besclient
#
#   and symbolic its link
#
# /(usr/)sbin/rcbesclient
#
# LSB compliant service control script; see http://www.linuxbase.org/spec/
#
# System startup script for some example service or daemon BESClient (template)
#
### BEGIN INIT INFO
# Provides: BESClient-10.0.16.61
# Required-Start: $remote_fs $syslog
# Required-Stop:  $remote_fs $syslog
# Default-Start:  2 3 5
# Default-Stop:   0 1 6
# Description:    Start BESClient daemon
### END INIT INFO

# Check for missing binaries (stale symlinks should not happen)
BESClient_BIN=/opt/BESClient/bin/BESClient
test -x $BESClient_BIN || exit 5

# Shell functions sourced from /etc/rc.status:
#      rc_check         check and set local and overall rc status
#      rc_status        check and set local and overall rc status
#      rc_status -v     ditto but be verbose in local rc status
#      rc_status -v -r  ditto and clear the local rc status
#      rc_failed        set local and overall rc status to failed
#      rc_failed <num>  set local and overall rc status to <num><num>
#      rc_reset         clear local rc status (overall remains)
#      rc_exit          exit appropriate to overall rc status
#      rc_active	checks whether a service is activated by symlinks
. /etc/rc.status

# First reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0 - success
# 1 - generic or unspecified error (failed)
# 2 - invalid or excess argument(s) (failed)
# 3 - unimplemented feature (e.g. "reload") (missing)
# 4 - insufficient privilege (failed)
# 5 - program is not installed (skipped)
# 6 - program is not configured (unused)
# 7 - program is not running (failed)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signalling is not supported) are
# considered a success.



case "$1" in
	start)
		/bin/echo -n "Starting BigFix: BESClient"

		# Check for existence of needed config file
		BESClient_CONFIG=/var/opt/BESClient/besclient.config
		BESClient_CONFIG_DEFAULT=/var/opt/BESClient/besclient.config.default
		if ! test -r $BESClient_CONFIG
		then
			if ! test -r $BESClient_CONFIG_DEFAULT
			then
				rc_failed 6
				rc_status -v
				rc_exit
			fi
		fi
		# For systemd services the system locale is set by systemd.
		# For legacy SysV services, we get it from /etc/sysconfig/language
		hasSystemd=0
		if test -e /etc/systemd && test -e /etc/os-release
		then
			. /etc/os-release
			if test -n $VERSION_ID
			then
				ver=`echo $VERSION_ID | sed 's/\..*$//' | sed 's/,.*$//'`
				test -n $ver && test $ver -ge 12 && hasSystemd=1
			fi
		fi
		if test $hasSystemd = 0
		then
			test -f /etc/sysconfig/language && . /etc/sysconfig/language
			export LC_ALL="$RC_LC_ALL"
			export LC_CTYPE="$RC_LC_CTYPE"
			export LANG="$RC_LANG"
		fi
		export XAUTHORITY=/root/.Xauthority
		export DISPLAY=:0
		export BESClientActionMastheadPath=/etc/opt/BESClient/actionsite.afxm
		# export BES_LIBPATH=/opt/BESClient/bin

		if ! test -r $BESClientActionMastheadPath
		then
			rc_failed 1
			rc_status -v
			rc_exit
		fi
		
		## limit access to client created files
		umask 077
		
		## Start daemon with startproc(8). If this fails
		## the echo return value is set appropriate.

		# NOTE: startproc returns 0, even if service is 
		# already running to match LSB spec.
		startproc $BESClient_BIN

		# Remember status and be verbose
		rc_status -v
		;;
	stop)
		/bin/echo -n "Stopping BigFix: BESClient"
		## Stop daemon with kill -TERM command and if it does not work executes kill -KILL
		## In case of failure set rc_failed.

		# Find pid.
		pid=`pgrep -o -f $BESClient_BIN`
		if [ -n "$pid" ]; then
			args=`cat /proc/$pid/cmdline`
		fi
		if [ -z "$pid" ] || [ -z "$args" ] || [ "$args" != "$BESClient_BIN" ]; then
			rc_failed 1
		else
			kill -TERM $pid
			sleep 0.2
			ps --pid $pid >/dev/null 2<&1
			running=$?
			delay=120
			count=0
			while [ "$running" -eq 0 ] && [ "$count" -lt "$delay" ]; do
				sleep 5 
				count=$(($count+5));
				ps --pid $pid >/dev/null 2<&1
				running=$?
			done 
			if [ "$count" -ge "$delay" ]; then
				kill -KILL $pid >/dev/null 2<&1
			fi
		fi

		# Remember status and be verbose
		rc_status -v
		;;
	try-restart)
		## Stop the service and if this succeeds (i.e. the 
		## service was running before), start it again.
		## Note: try-restart is not (yet) part of LSB (as of 0.7.5)
		$0 status >/dev/null &&  $0 restart

		# Remember status and be quiet
		rc_status
		;;
	restart)
		## Stop the service and regardless of whether it was
		## running or not, start it again.
		$0 stop
		$0 start

		# Remember status and be quiet
		rc_status
		;;
	force-reload)
		## Signal the daemon to reload its config. Most daemons
		## do this on signal 1 (SIGHUP).
		## If it does not support it, restart.

		/bin/echo -n "Reload service BigFix: BESClient"
		## if it supports it:
		#killproc -HUP $BESClient_BIN
		#touch /var/run/BESClient.pid
		#rc_status -v

		## Otherwise:
		$0 stop  &&  $0 start
		rc_status
		;;
	reload)
		## Like force-reload, but if daemon does not support
		## signalling, do nothing (!)

		# If it supports signalling:
		#/bin/echo -n "Reload service BigFix: BESClient"
		#killproc -HUP $BESClient_BIN
		#touch /var/run/BESClient.pid
		#rc_status -v

		## Otherwise if it does not support reload:
		rc_failed 3
		rc_status -v
		;;
	status)
		/bin/echo -n "Checking for service BigFix: BESClient: "
		## Check status with checkproc(8), if process is running
		## checkproc will return with exit status 0.

		# Return value is slightly different for the status command:
		# 0 - service running
		# 1 - service dead, but /var/run/  pid  file exists
		# 2 - service dead, but /var/lock/ lock file exists
		# 3 - service not running

		# NOTE: checkproc returns LSB compliant status values.
		checkproc $BESClient_BIN
		rc_status -v
		;;
	*)
		/bin/echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}"
		exit 1
		;;
esac
rc_exit
